#ifndef DATA_SOCKET_CLASS_H
#define DATA_SOCKET_CLASS_H
	
#include <XRS/Socket.h>
#include <stdio.h>
#include <sstream>

namespace XRS{

#define EOD     "\x44"
class DataSocket:public Socket{
   FILE *fp;
 public:
   DataSocket(const char *ss):Socket(ss),fp(NULL){}
   operator FILE*(){ return fp;}
   FILE * open(){
       if(fp) close();
       fp=fdopen(Socket::open(),"w");  return fp;
   }
   void close(){
     if(fp){fprintf(fp,EOD); fflush(fp); fclose(fp); Socket::close();} fp=NULL;
   }

   template<class T> DataSocket& operator<<(const T& s){ 
     std::ostringstream os; os<<s;
     fprintf(fp,"%s",os.str().c_str()); fflush(fp); return *this; 
   }
   DataSocket& operator<<(std::ostream& (*pf)(std::ostream &)){
     std::ostringstream os; os<<pf;
     fprintf(fp,"%s",os.str().c_str()); fflush(fp); return *this; 
   }

};

#undef EOD
 }/*namespace XRS*/ 
#endif
